# coding: utf-8

"""
    everai/apps/v1/worker.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
from generated.apps.models.app_spec_v1_alpha1_route_auth_type import AppSpecV1Alpha1RouteAuthType
from generated.apps.models.v1_autoscaler import V1Autoscaler
from generated.apps.models.v1_environment import V1Environment
from generated.apps.models.v1_image_pull_secrets import V1ImagePullSecrets
from generated.apps.models.v1_probe import V1Probe
from generated.apps.models.v1_resource import V1Resource
from generated.apps.models.v1_volume import V1Volume
from generated.apps.models.v1_volume_mount import V1VolumeMount
from typing import Dict, Any
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class V1AppSpecV1Alpha1(BaseModel):
    """
    V1AppSpecV1Alpha1
    """
    image: Optional[StrictStr] = None
    image_pull_secrets: Optional[V1ImagePullSecrets] = Field(default=None, alias="imagePullSecrets")
    volume_mounts: Optional[List[V1VolumeMount]] = Field(default=None, alias="volumeMounts")
    env: Optional[List[V1Environment]] = None
    command: Optional[List[StrictStr]] = None
    port: Optional[StrictInt] = None
    readiness_probe: Optional[V1Probe] = Field(default=None, alias="readinessProbe")
    volumes: Optional[List[V1Volume]] = None
    resource: V1Resource
    route_auth_type: Optional[AppSpecV1Alpha1RouteAuthType] = Field(default=None, alias="routeAuthType")
    route_public_key: Optional[StrictStr] = Field(default=None, alias="routePublicKey")
    autoscaler: Optional[V1Autoscaler] = None
    __properties: ClassVar[List[str]] = ["image", "imagePullSecrets", "volumeMounts", "env", "command", "port", "readinessProbe", "volumes", "resource", "routeAuthType", "routePublicKey", "autoscaler"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of V1AppSpecV1Alpha1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of image_pull_secrets
        if self.image_pull_secrets:
            _dict['imagePullSecrets'] = self.image_pull_secrets.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in volume_mounts (list)
        _items = []
        if self.volume_mounts:
            for _item in self.volume_mounts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['volumeMounts'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in env (list)
        _items = []
        if self.env:
            for _item in self.env:
                if _item:
                    _items.append(_item.to_dict())
            _dict['env'] = _items
        # override the default output from pydantic by calling `to_dict()` of readiness_probe
        if self.readiness_probe:
            _dict['readinessProbe'] = self.readiness_probe.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in volumes (list)
        _items = []
        if self.volumes:
            for _item in self.volumes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['volumes'] = _items
        # override the default output from pydantic by calling `to_dict()` of resource
        if self.resource:
            _dict['resource'] = self.resource.to_dict()
        # override the default output from pydantic by calling `to_dict()` of autoscaler
        if self.autoscaler:
            _dict['autoscaler'] = self.autoscaler.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Self:
        """Create an instance of V1AppSpecV1Alpha1 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "image": obj.get("image"),
            "imagePullSecrets": V1ImagePullSecrets.from_dict(obj.get("imagePullSecrets")) if obj.get("imagePullSecrets") is not None else None,
            "volumeMounts": [V1VolumeMount.from_dict(_item) for _item in obj.get("volumeMounts")] if obj.get("volumeMounts") is not None else None,
            "env": [V1Environment.from_dict(_item) for _item in obj.get("env")] if obj.get("env") is not None else None,
            "command": obj.get("command"),
            "port": obj.get("port"),
            "readinessProbe": V1Probe.from_dict(obj.get("readinessProbe")) if obj.get("readinessProbe") is not None else None,
            "volumes": [V1Volume.from_dict(_item) for _item in obj.get("volumes")] if obj.get("volumes") is not None else None,
            "resource": V1Resource.from_dict(obj.get("resource")) if obj.get("resource") is not None else None,
            "routeAuthType": obj.get("routeAuthType"),
            "routePublicKey": obj.get("routePublicKey"),
            "autoscaler": V1Autoscaler.from_dict(obj.get("autoscaler")) if obj.get("autoscaler") is not None else None
        })
        return _obj


